unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, XPMan;

type
  TfrmMain = class(TForm)
    ListView1: TListView;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    XPManifest1: TXPManifest;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  anzahl_patches : Integer;
  oribytes, patchbytes, offsets : array[1..1000] of Integer;
  filesize : longint;
  target_file : string;
  target_name : string;
  authorname : string;

implementation

{$R *.dfm}

procedure MyBox(text,cap : string);
begin
  MessageBox(frmMain.handle,pchar(text),pchar(cap),mb_iconinformation);
end;

procedure TfrmMain.Button3Click(Sender: TObject);
var
  file1, file2 : TMemoryStream;
  i : Integer;
  Pbuf1, Pbuf2 : ^byte;
  buf1, buf2 : byte;
  NewEntry : TListItem;
begin
  // if there was already an comparison, delete it!
  for i := listview1.items.count-1 downto 0 do
    listview1.Items.delete(i);


  anzahl_patches := 0;
  if (edit1.text = '') or (edit2.text = '') then
  begin
    Mybox('Please choose 2 files!','Error');
    exit;
  end;

  file1 := TMemoryStream.Create;
  file2 := TMemoryStream.Create;
  file1.LoadFromFile(edit1.text);
  file2.LoadFromFile(edit2.text);
  if file1.Size <> file2.size then
  begin
    MyBox('Files must have the same size! Sorry!','Different file sizes');
    exit;
  end;
  //Edit6.Text := inttostr(file1.size)+ ' Bytes';
  filesize := file1.size;
  //edit4.text := ExtractFileName(edit1.text);
  //edit7.Text:=edit4.text;
  Pbuf1 := file1.Memory;
  Pbuf2 := file2.Memory;
  for i := 0 to file1.size do
  begin
    buf1 := Pbuf1^;
    buf2 := Pbuf2^;
    if buf1 <> buf2 then
    begin
      inc(Anzahl_patches);
      //if anzahl_patches = 1000 then
      //begin
      //  MyBox('Maximum of 1000 differences reached. Aborting...', 'Too many differences...');
      //  exit;
      //end;

      
      NewEntry := frmMain.listview1.items.add;
      NewEntry.caption := inttohex(i,8);
      NewEntry.subitems.add(inttohex(buf1,2));
      NewEntry.subitems.add(inttohex(buf2,2));


      oribytes[anzahl_patches] := buf1;
      patchbytes[anzahl_patches] := buf2;
      offsets[anzahl_patches] := i;
    end;
    inc(pbuf1);
    inc(pbuf2);
  end;
  file1.free;
  file2.free;
end;

procedure TfrmMain.Button1Click(Sender: TObject);
begin
  If Opendialog1.execute then
    edit1.text := opendialog1.FileName;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
  If Opendialog1.execute then
    edit2.text := opendialog1.FileName;
end;

procedure TfrmMain.Button4Click(Sender: TObject);
begin
MessageBox(frmMain.handle,'File CompareR v1.0a'+#10#13+
                          'New Searching Engine! :)'+#13#10+
                          'Date: 03/04/06'+#13#10#13#10+
                          'Author: Guru.eXe/TMX'+#13#10+
                          'EMail: DarkGuru@pisem.net'+#13#10+
                          'Web: http://www.team-x.ru'+#13#10#13#10+
                          'Thank YOU for USE!','About',mb_iconinformation);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
application.Title:=frmmain.Caption;
end;

end.
